MPEG(1)                  USER COMMANDS                    MPEG(1)

NAME
     mpeg - MPEG compression and decompression

SYNOPSIS
     mpeg [-d] [-NTSC] [-CIF] [-QCIF] [-PF] [-NPS]  [-MBPS  mbps]
     [-UTC]
          [-a StartNumber] [-b EndNumber]
          [-h HorizontalSize] [-v VerticalSize]
          [-f FrameInterval] [-g GroupInterval]
          [-4] [-c] [-i MCSearchLimit] [-o] [-p PictureRate]
          [-q Quantization] [-r Target Rate]
          [-s StreamFile]  [-x Target Filesize] [-y]
          [-z ComponentFileSuffix i]
          ComponentFilePrefix1     [ComponentFilePrefix2     Com-
     ponentFilePrefix3]

DESCRIPTION
     mpeg      is      a      multimedia      image      sequence
     compression/decompression  program that performs MPEG encod-
     ing and decoding.

OPTIONS
     -NTSC
          indicates that the source frame size for the  Luminance
          component is 352x240 and for the Chrominance components
          is 176x120. This is the default size.
     -CIF indicates that the source frame size for the  Luminance
          component is 352x288 and for the Chrominance components
          is 176x144.
     -QCIF
          indicates that the source frame size for the  Luminance
          component is 176x144 and for the Chrominance components
          is 88x72.
     -PF  indicates that the component sizes specified by -h  and
          -v  are  not  multiples  of 16 and furthermore that the
          input files (or output files) should  be  exactly  that
          specified  by  the component size -h and -v (or as read
          from the compressed stream).  Otherwise the  input  and
          output files will be the component size rounded up to a
          multiple of 16 in each dimension.
     -NPS The NPS option allows the  encoder  to  encode  without
          having  the  restriction  that the last macroblock in a
          slice cannot be  skipped.   For  coding  purposes,  the
          first macroblock in a slice must be coded, although the
          decoder will probably handle that case as well.
     -MBPS
          This specifies the  macroblocks  per  slice.   If  left

AT&T Bell Laboratories Last change: 24 February 1993                 1


MPEG(1)                  USER COMMANDS                    MPEG(1)

          unspecified then the number of macroblocks per slice is
          the number of macroblocks on one row of the image.
     -UTC Forces the frame number  of  the  image  to  match  the
          Group-of-Pictures  time  code.   Only  useful  for  the
          decoder.
     -a   denotes the following value to  be  the  start  of  the
          filename index [inclusive]. Defaults to 0.
     -b   denotes the following  value  to  be  the  end  of  the
          filename index [inclusive]. Defaults to 0.
     -d   enables the decoder.  The only options useful  for  the
          decoder  are  the filename specifications and the -NPS,
          -UTC commmands; the rest of the  command-line  informa-
          tion is used for encoding.
     -h   is the horizontal size of the picture in terms  of  the
          luminance  component, used for a non -NTSC, -CIF, -QCIF
          filesize.  See the preceding note about -PF  about  the
          dimensions  of  the  file  relative to that of the com-
          ponent.
     -v   is the vertical size of the picture  in  terms  of  the
          luminance  component, used for a non -NTSC, -CIF, -QCIF
          filesize.  See the preceding note about -PF  about  the
          dimensions  of  the  file  relative to that of the com-
          ponent.
     -f   is the  number  of  interpolated  frames  between  each
          intra/predicted  frame.   FrameInterval-1 is the number
          of interpolated frames within each frame interval.
     -g   is the number of frame intervals per group-of-pictures.
          With  a group interval of 1 then there are no predicted
          frames.  The value GroupInterval-1  is  the  number  of
          predicted frames in each group of pictures.
     -4   is used to DC Intraframe mode where only  the  DC  com-
          ponents of each picture block is coded.
     -i   is the diameter of the motion  estimation  search.  The
          diameter  must  be inclusively between 1 and 15, desig-
          nating a region from interframe only (0,0)  search,  to
          full search (+- 7.5, +- 7.5).  The motion estimation is
          telescopic for frame distances  greater  than  1  (thus
          having a greater effective range).
     -o   signals that the program interpreter will read the con-
          trol algorithms from the standard input.

AT&T Bell Laboratories Last change: 24 February 1993                 2


MPEG(1)                  USER COMMANDS                    MPEG(1)

     -p   specifies the picture rate by a  code  directly  placed
          into  the stream.  It must be a number between 0 and 8.
          (default 5=30Hz).
     -q   gives a value for the quantization not in the  presence
          of rate control (rate control automatically changes the
          quantization values).  If rate  control  is  specified,
          this  parameter gives a value for the initial quantiza-
          tion of the first  frame  (which  the  program  usually
          takes an educated guess at).
     -r   specified a rate for  the  coded  stream.  If  this  is
          enabled,  a  buffer  model is used to limit the size of
          the coding stream. Note  this  is  given  in  bits  per
          second.
     -s   specifies the filename to store  the  coded  image.  If
          unspecified it defaults to ComponentFilePrefix0.mpg.
     -v   designates that quantization decisions are to be  writ-
          ten to standard output. This is the verbose mode.
     -x   gives a target filesize for the compressed stream. This
          overrides  the  rate  option  -r, if specified. This is
          specified in bits.  The actual implementation  of  this
          technique  is  through  calculating the equivalent bit-
          rate. Since the buffer usually has some contents at the
          end  of coding, the final filesize is larger than actu-
          ally designated.
     -y   enables the double-precision floating  point  Reference
          DCT. The default is the Chen DCT.
     -z   denotes  the  component  file  suffixes  in  sequential
          order. For example
           -z .y.clr -z .u.clr -z .v.clr indicates that the lumi-
          nance  and  the two chrominance files end with a suffix
          of .y.clr,  .u.clr,  and  .v.clr,  in  that  order.  If
          unspecified, the suffixes default to .Y, U, and .V.
     ComponentFilePrefixn
          must be specified.  In  general,  the  other  component
          files  share  the  same prefix and will default to Com-
          ponentFilePrefix1 if not explicitly specified. However,
          in  some  cases  the prefix is what changes in the file
          and we can specify this individually.

EXAMPLES
     To encode a set of raw raster scan YUV files with  dimension
     352x240  Y,  176x120  U,V,  with  labels,  hello0.Y hello0.U
     hello0.V,  hello1.Y  hello1.U   hello1.V,   ...,   hello12.Y
     hello12.U hello12.V through the mpeg encoder, type

AT&T Bell Laboratories Last change: 24 February 1993                 3


MPEG(1)                  USER COMMANDS                    MPEG(1)

     mpeg -a 0 -b 12 hello -s hello.mpg
     This creates the output file hello.mpg. In order  to  decode
     such a file into a sequence of image files with prefix good-
     bye, type
     mpeg -d -s hello.mpg goodbye
     The output will be placed in the files goodbye0.Y goodbye0.U
     goodbye0.V,    goodbye1.Y    goodbye1.U   goodbye1.V,   ...,
     goodbye12.Y goodbye12.U goodbye12.V.  These image  sequences
     can  be  displayed  by the cv program available by anonymous
     ftp from havefun.stanford.edu:pub/cv/CVv1.1.tar.Z. There are
     more options within an internal program interpreter.  Please
     see  the  accompanying  documentation  in  doc.ps  for  more
     details.

FTP
     mpeg    is    available    by     anonymous     ftp     from
     havefun.stanford.edu:pub/mpeg/MPEGv1.1.tar.Z.

BUGS
     Somewhat  slower  than  many   commercial   implementations.
     Please  inform  the  author at achung@cs.stanford.edu if any
     bugs are found.

AUTHOR
     Andy Hung

AT&T Bell Laboratories Last change: 24 February 1993                 4
